#ifndef LIFE_H
#define LIFE_H (1)

#include "board.h"
#include <stdint.h>
#include <ostream>

namespace gol
{

    /** Implementation of the Game of Life on a generic game board
     */
    class Life : public Board
    {
        public:
            Life(uint8_t width, uint8_t height, uint16_t historySize);
            bool play();
            uint8_t countNeighbours(uint8_t x, uint8_t y) const;

    };

    class iterator_helper {
        public:
            friend std::ostream& operator<< (std::ostream& os, iterator_helper &i);
    };
}

#endif
